import { constVoid, pipe } from 'fp-ts/function';
export function put(F) {
    return function (i) { return function () { return F.of([constVoid(), i]); }; };
}
export function ixmodify(F) {
    return function (f) { return function (i) { return F.of([constVoid(), f(i)]); }; };
}
export function get(F) {
    return function () { return function (i) { return F.of([i, i]); }; };
}
export function gets(F) {
    return function (f) { return function (i) { return F.of([f(i), i]); }; };
}
export function fromStateF() {
    return function (fa) { return fa; };
}
export function toStateF() {
    return function (fa) { return fa; };
}
export function ixexecute(F) {
    return function (i) { return function (fa) { return F.map(fa(i), function (ao) { return ao[1]; }); }; };
}
export function evaluate(F) {
    return function (i) { return function (fa) { return F.map(fa(i), function (ao) { return ao[0]; }); }; };
}
export function ixof(F) {
    return function (a) { return function (i) { return F.of([a, i]); }; };
}
/**
 * @category Pointed
 * @since 2.10.0
 */
export var of = ixof;
export function ixmap(F) {
    return function (f) { return function (fa) { return function (i) { return F.map(fa(i), function (_a) {
        var a = _a[0], o = _a[1];
        return [f(a), o];
    }); }; }; };
}
/**
 * `map` can be used to turn functions `(a: A) => B` into functions `(fa: F<A>) => F<B>` whose argument and return types
 * use the type constructor `F` to represent some computational context.
 *
 * @category Functor
 * @since 2.10.0
 */
export var map = ixmap;
export function ixap(F) {
    return function (fa) { return function (fab) {
        return pipe(fab, ixchain(F)(function (f) { return map(F)(f)(fa); }));
    }; };
}
export function ap(F) {
    return function (fa) { return function (fab) {
        return pipe(fab, ixchain(F)(function (f) { return map(F)(f)(fa); }));
    }; };
}
export function ixchain(F) {
    return function (f) { return function (fa) { return function (i) { return F.chain(fa(i), function (_a) {
        var a = _a[0], o = _a[1];
        return f(a)(o);
    }); }; }; };
}
export function chain(F) {
    return function (f) { return function (fa) { return function (i) { return F.chain(fa(i), function (_a) {
        var a = _a[0], o = _a[1];
        return f(a)(o);
    }); }; }; };
}
export function local() {
    return function (f) { return function (fa) { return function (x) { return fa(f(x)); }; }; };
}
