"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.local = exports.chain = exports.ixchain = exports.ap = exports.ixap = exports.map = exports.ixmap = exports.of = exports.ixof = exports.evaluate = exports.ixexecute = exports.toStateF = exports.fromStateF = exports.gets = exports.get = exports.ixmodify = exports.put = void 0;
var function_1 = require("fp-ts/function");
function put(F) {
    return function (i) { return function () { return F.of([function_1.constVoid(), i]); }; };
}
exports.put = put;
function ixmodify(F) {
    return function (f) { return function (i) { return F.of([function_1.constVoid(), f(i)]); }; };
}
exports.ixmodify = ixmodify;
function get(F) {
    return function () { return function (i) { return F.of([i, i]); }; };
}
exports.get = get;
function gets(F) {
    return function (f) { return function (i) { return F.of([f(i), i]); }; };
}
exports.gets = gets;
function fromStateF() {
    return function (fa) { return fa; };
}
exports.fromStateF = fromStateF;
function toStateF() {
    return function (fa) { return fa; };
}
exports.toStateF = toStateF;
function ixexecute(F) {
    return function (i) { return function (fa) { return F.map(fa(i), function (ao) { return ao[1]; }); }; };
}
exports.ixexecute = ixexecute;
function evaluate(F) {
    return function (i) { return function (fa) { return F.map(fa(i), function (ao) { return ao[0]; }); }; };
}
exports.evaluate = evaluate;
function ixof(F) {
    return function (a) { return function (i) { return F.of([a, i]); }; };
}
exports.ixof = ixof;
/**
 * @category Pointed
 * @since 2.10.0
 */
exports.of = ixof;
function ixmap(F) {
    return function (f) { return function (fa) { return function (i) { return F.map(fa(i), function (_a) {
        var a = _a[0], o = _a[1];
        return [f(a), o];
    }); }; }; };
}
exports.ixmap = ixmap;
/**
 * `map` can be used to turn functions `(a: A) => B` into functions `(fa: F<A>) => F<B>` whose argument and return types
 * use the type constructor `F` to represent some computational context.
 *
 * @category Functor
 * @since 2.10.0
 */
exports.map = ixmap;
function ixap(F) {
    return function (fa) { return function (fab) {
        return function_1.pipe(fab, ixchain(F)(function (f) { return exports.map(F)(f)(fa); }));
    }; };
}
exports.ixap = ixap;
function ap(F) {
    return function (fa) { return function (fab) {
        return function_1.pipe(fab, ixchain(F)(function (f) { return exports.map(F)(f)(fa); }));
    }; };
}
exports.ap = ap;
function ixchain(F) {
    return function (f) { return function (fa) { return function (i) { return F.chain(fa(i), function (_a) {
        var a = _a[0], o = _a[1];
        return f(a)(o);
    }); }; }; };
}
exports.ixchain = ixchain;
function chain(F) {
    return function (f) { return function (fa) { return function (i) { return F.chain(fa(i), function (_a) {
        var a = _a[0], o = _a[1];
        return f(a)(o);
    }); }; }; };
}
exports.chain = chain;
function local() {
    return function (f) { return function (fa) { return function (x) { return fa(f(x)); }; }; };
}
exports.local = local;
